.terraform_static_site:
  stage: .pre
  allow_failure: true
  needs: []
  image: $CI_TEMPLATE_REGISTRY_HOST/gitlab-org/terraform-images/stable:latest
  variables:
    TF_ROOT: $CI_PROJECT_DIR/terraform-static-site
    TF_STATE_NAME: $ENVIRONMENT
    TF_VAR_ENVIRONMENT: $ENVIRONMENT
    TF_VAR_PROJECT_NAME: $PROJECT_NAME
    TF_VAR_REPOSITORY_NAME: $CI_PROJECT_NAME
  before_script:
    - git clone https://gitlab.com/ibisdev.tech/ci-addons/terraform-static-site.git
    - cd $TF_ROOT

    - source gitlab-terraform init
  script:
    - terraform apply -auto-approve

    - git clone https://gitlab.com/ibisdev.tech/ci-addons/create-ci-variables.git
    - cp create-ci-variables/*-variable /usr/bin
    - chmod +x /usr/bin/*-variable

    - create-variable "BUCKET_NAME" "$(terraform output --raw s3_bucket_id)" "$ENVIRONMENT"
    - delete-variable "ADDONS_CREATE_STATIC_SITE"

terraform_static_site_dev:
  extends: .terraform_static_site
  variables:
    ENVIRONMENT: dev
  rules:
    - if: $ADDONS_CREATE_STATIC_SITE && $DEV_ENABLED && $CI_COMMIT_REF_PROTECTED == "true"

terraform_static_site_qa:
  extends: .terraform_static_site
  variables:
    ENVIRONMENT: qa
  rules:
    - if: $ADDONS_CREATE_STATIC_SITE && $QA_ENABLED && $CI_COMMIT_REF_PROTECTED == "true"

terraform_static_site_staging:
  extends: .terraform_static_site
  variables:
    ENVIRONMENT: staging
  rules:
    - if: $STAGING_DISABLED
      when: never
    - if: $ADDONS_CREATE_STATIC_SITE && $CI_COMMIT_REF_PROTECTED == "true"

terraform_static_site_production:
  extends: .terraform_static_site
  variables:
    ENVIRONMENT: production
  rules:
    - if: $PRODUCTION_DISABLED
      when: never
    - if: $ADDONS_CREATE_STATIC_SITE && $CI_COMMIT_REF_PROTECTED == "true"
